--- postfix-2.0.7/src/smtp/smtp_connect.c.orig	Fri Jan 24 01:07:53 2003
+++ postfix-2.0.7/src/smtp/smtp_connect.c	Thu Apr  3 21:44:48 2003
@@ -364,20 +364,17 @@
     char   *host;
     unsigned port;
     char   *def_service = "smtp";	/* XXX configurable? */
-    ARGV   *sites;
+    char   *save;
     char   *dest;
-    char  **cpp;
+    char   *cp;
     int     found_myself = 0;
 
     /*
      * First try to deliver to the indicated destination, then try to deliver
      * to the optional fall-back relays.
      */
-    sites = argv_alloc(1);
-    argv_add(sites, destination, (char *) 0);
-    argv_split_append(sites, var_fallback_relay, ", \t\r\n");
-
-    for (cpp = sites->argv; (dest = *cpp) != 0; cpp++) {
+    cp = save = concatenate(destination, " ", var_fallback_relay, (char *) 0);
+    while ((dest = mystrtok(&cp, ", \t\r\n")) != 0) {
 
 	/*
 	 * Parse the destination. Default is to use the SMTP port.
@@ -422,8 +419,8 @@
 		     VAR_RELAYHOST, var_relayhost);
 	    smtp_errno = SMTP_RETRY;
 	}
-	if (cpp > sites->argv && sites->argc > 1) {
-	    msg_warn("%s problem: %s",
+	if (*var_fallback_relay) {
+	    msg_warn("%s configuration problem: %s",
 		     VAR_FALLBACK_RELAY, var_fallback_relay);
 	    smtp_errno = SMTP_RETRY;
 	}
@@ -432,6 +429,6 @@
     /*
      * Cleanup.
      */
-    argv_free(sites);
+    myfree(save);
     return (session);
 }
